import { writable } from "svelte/store"

interface PaginationState {
	currentPage: number
	pageSize: number
	totalItems?: number // page number rendering (+ caching metadata)
}

// limit and offset (`pageSize` and `currentPage`) values align initially with backend defaults,
// but should be adjusted based on the UI state/dimensions

export const notesPagination = writable<PaginationState>({
	currentPage: 0,
	pageSize: 50
})

export const usersPagination = writable<PaginationState>({
	currentPage: 0,
	pageSize: 50
})
